## units-cpp 2.3.3%2Bds

=== debian/control ===
Source: units-cpp
Section: libdevel
Priority: optional
Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.2),
 libgtest-dev,
 locales-all
Standards-Version: 4.6.2
Homepage: https://github.com/nholthaus/units
Vcs-Browser: https://salsa.debian.org/werdahias/units
Vcs-Git: https://salsa.debian.org/werdahias/units.git

Package: libunits-cpp-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: unit conversion library for c++ (development files)
 a compile-time, header-only, dimensional analysis and unit conversion library
 built on c++14 with no dependencies.
 .
 This is a header-only library.
