## units-cpp 2.3.3+ds

=== debian/changelog ===
units-cpp (2.3.3+ds-4) unstable; urgency=medium

  * Add patch to fix FTBFS with GCC 14 (Closes: #1077396)
  * Updated my mail adress in d/control, d/copyright
  * Bump Standards-Version to 4.7.0, no changes needed
  * d/salsa-ci.yml: disable i386 build

 -- Matthias Geiger <werdahias@debian.org>  Wed, 07 Aug 2024 21:03:50 +0200

units-cpp (2.3.3+ds-3) unstable; urgency=medium

  * Mark units-cpp as Architecture: All and Multi-Arch: foreign
  * Source-only upload

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sat, 28 Jan 2023 17:16:30 +0100

units-cpp (2.3.3+ds-2) unstable; urgency=medium

  * Upload to unstable
  * Source-only upload

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Thu, 26 Jan 2023 11:23:20 +0100

units-cpp (2.3.3+ds-1) experimental; urgency=medium

  * Initial release. (Closes: #1019715)

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Thu, 19 Jan 2023 23:21:38 -0700
