=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: units-cpp
 Section: libdevel
 Priority: optional
-Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
+Maintainer: Matthias Geiger <werdahias@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 3.2),
  libgtest-dev,
  locales-all
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/nholthaus/units
 Vcs-Browser: https://salsa.debian.org/werdahias/units
 Vcs-Git: https://salsa.debian.org/werdahias/units.git
