## units-cpp 2.3.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.2...3.5 FATAL_ERROR)
 
 PROJECT(units LANGUAGES CXX)
 set(units_VERSION 2.3.1)
