=== debian/changelog ===
units-cpp (2.3.4+ds-2) unstable; urgency=medium

  * d/patches: Include upstream commit to build with cmake4 (Closes: #1113604)
  * d/p: Add patch bumping CXX_STANDARD (Closes: #1114426)

 -- Matthias Geiger <werdahias@debian.org>  Mon, 08 Sep 2025 20:39:47 +0200

units-cpp (2.3.4+ds-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update VCS urls
  * salsa-ci.yml: Stop disabling CI on i386

 -- Matthias Geiger <werdahias@debian.org>  Sat, 21 Dec 2024 15:33:07 +0100
