=== debian/control ===
--- 
+++ 
@@ -10,8 +10,8 @@
  locales-all
 Standards-Version: 4.7.0
 Homepage: https://github.com/nholthaus/units
-Vcs-Browser: https://salsa.debian.org/werdahias/units
-Vcs-Git: https://salsa.debian.org/werdahias/units.git
+Vcs-Browser: https://salsa.debian.org/debian/units-cpp
+Vcs-Git: https://salsa.debian.org/debian/units-cpp.git
 
 Package: libunits-cpp-dev
 Architecture: all
