=== debian/watch ===
version=4
opts=\
repacksuffix=+ds,\
repack,compression=gz,\
dversionmangle=s/\+(ds)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/units-$1\.tar\.gz/ \
  https://github.com/nholthaus/units/tags  .*/v?([\d.]*)@ARCHIVE_EXT@
